filebrowser/urls.py
from django.conf.urls.defaults import *

urlpatterns = patterns('filebrowser.views',
    
    url(r'^(?P<dir_name>[_a-zA-Z0-9./-]+)/mkdir/', 'mkdir'),
    url(r'^(?P<dir_name>[_a-zA-Z0-9./-]+)/upload/', 'upload'),
    url(r'^(?P<dir_name>[_a-zA-Z0-9./-]+)/delete/$', 'delete'),
    url(r'^(?P<dir_name>[_a-zA-Z0-9./-]+)/makethumbs/$', 'makethumb'),
    url(r'^(?P<dir_name>[_a-zA-Z0-9./-]+)/makethumb/(?P<file_name>[a-zA-Z0-9._-]+)', 'makethumb'),
    url(r'^(?P<dir_name>[_a-zA-Z0-9./-]+)/generateimages/$', 'generateimages'),
    url(r'^(?P<dir_name>[_a-zA-Z0-9./-]+)/generateimages/(?P<file_name>[a-zA-Z0-9._-]+)', 'generateimages'),
    url(r'^(?P<dir_name>[_a-zA-Z0-9./-]+)/rename/(?P<file_name>[a-zA-Z0-9._-]+)', 'rename'),
    url(r'^mkdir/', 'mkdir'),
    url(r'^upload/', 'upload'),
    url(r'^delete/$', 'delete'),
    url(r'^makethumbs/$', 'makethumb'),
    url(r'^makethumb/(?P<file_name>[a-zA-Z0-9._-]+)', 'makethumb'),
    url(r'^generateimages/$', 'generateimages'),
    url(r'^generateimages/(?P<file_name>[a-zA-Z0-9._-]+)', 'generateimages'),
    url(r'^rename/(?P<file_name>[a-zA-Z0-9._-]+)', 'rename'),
    url(r'^(?P<dir_name>[_a-zA-Z0-9./-]+)/$', 'index'),
    url(r'^$', 'index', name='filebrowser-index'),

)

filebrowser/forms.py
# coding: utf-8

from django import forms
from django.forms.formsets import BaseFormSet
from django.utils.translation import ugettext as _
import re, os

# get settings
from filebrowser.fb_settings import *
# get functions
from filebrowser.functions import _get_file_type

alnum_name_re = re.compile(r'^[a-zA-Z0-9._/-]+$')


class MakeDirForm(forms.Form):
    
    def __init__(self, path_server, path, *args, **kwargs):
        self.PATH_SERVER = path_server
        self.path = path
        super(MakeDirForm, self).__init__(*args, **kwargs)
    
    dir_name = forms.CharField(widget=forms.TextInput(attrs=dict({ 'class': 'vTextField' }, max_length=50, min_length=3)), label=_(u'Name'), help_text=_(u'The Name will automatically be converted to lowercase. Only letters, numbers, underscores and hyphens are allowed.'), required=True)
                     
    def clean_dir_name(self):
        
        if self.cleaned_data['dir_name']:
            # only letters, numbers and underscores are allowed.
            if not alnum_name_re.search(self.cleaned_data['dir_name']):
                raise forms.ValidationError(_(u'Only letters, numbers, underscores and hyphens are allowed.'))
            # directory must not already exist.
            if os.path.isdir(os.path.join(self.PATH_SERVER, self.path, self.cleaned_data['dir_name'].lower())):
                raise forms.ValidationError(_(u'The Folder already exists.'))
            # check banned folder names
            if self.cleaned_data['dir_name'] in DISALLOWED_FOLDER_NAMES:
                raise forms.ValidationError(_(u'Disallowed Folder Name.'))
        
        return self.cleaned_data['dir_name']
    

class RenameForm(forms.Form):

    def __init__(self, path_server, path, file_extension, *args, **kwargs):
        self.PATH_SERVER = path_server
        self.path = path
        self.file_extension = file_extension
        super(RenameForm, self).__init__(*args, **kwargs)
    
    name = forms.CharField(widget=forms.TextInput(attrs=dict({ 'class': 'vTextField' }, max_length=50, min_length=3)), label=_(u'New Name'), help_text=_('The Name will automatically be converted to lowercase. Only letters, numbers, underscores and hyphens are allowed.'), required=True)
    
    def clean_name(self):
    
        if self.cleaned_data['name']:
            # only letters, numbers and underscores are allowed.
            if not alnum_name_re.search(self.cleaned_data['name']):
                raise forms.ValidationError(_(u'Only letters, numbers, underscores and hyphens are allowed.'))
            # file/directory must not already exist.
            if os.path.isdir(os.path.join(self.PATH_SERVER, self.path, self.cleaned_data['name'].lower())) or os.path.isfile(os.path.join(self.PATH_SERVER, self.path, self.cleaned_data['name'].lower() + self.file_extension)):
                raise forms.ValidationError(_(u'The File/Folder already exists.'))
        
        return self.cleaned_data['name']
    

class BaseUploadFormSet(BaseFormSet):

    # this is just for passing the parameters (path_server, path) to the uploadform.
    # overly complicated, but necessary for the clean-methods in UploadForm.
    # DO NOT CHANGE ANYTHING HERE.
    # if you need to make modifications to the uploadform - use UploadForm below.
    
    def __init__(self, **kwargs):
        self.path_server = kwargs['path_server']
        self.path = kwargs['path']
        del kwargs['path_server']
        del kwargs['path']
        super(BaseUploadFormSet, self).__init__(**kwargs)
    
    def _construct_form(self, i, **kwargs):
        # this works because BaseFormSet._construct_form() passes **kwargs
        # to the form's __init__()
        kwargs["path_server"] = self.path_server
        kwargs["path"] = self.path
        return super(BaseUploadFormSet, self)._construct_form(i, **kwargs)
    

class UploadForm(forms.Form):
    
    def __init__(self, *args, **kwargs):
        self.path_server = kwargs['path_server']
        self.path = kwargs['path']
        del kwargs['path_server']
        del kwargs['path']
        super(UploadForm, self).__init__(*args, **kwargs)
    
    file = forms.FileField(label=_(u'File'))
    use_image_generator = forms.BooleanField(label=_(u'Use Image Generator'), required=False)
    
    def clean_file(self):
        if self.cleaned_data['file']:
            filename = self.cleaned_data['file'].name
            
            # CHECK IF FILE EXISTS
            dir_list = os.listdir(os.path.join(self.path_server, self.path))
            if filename in dir_list:
                raise forms.ValidationError(_(u'File already exists.'))
                
            # TODO: CHECK IF VERSIONS_PATH EXISTS (IF USE_IMAGE_GENERATOR IS TRUE)
            
            # CHECK FILENAME
            if not alnum_name_re.search(filename):
                raise forms.ValidationError(_(u'Filename is not allowed.'))
                
            # CHECK EXTENSION / FILE_TYPE
            file_type = _get_file_type(filename)
            if not file_type:
                raise forms.ValidationError(_(u'File extension is not allowed.'))
                
            # CHECK FILESIZE
            filesize = self.cleaned_data['file'].size
            if filesize > MAX_UPLOAD_SIZE:
                raise forms.ValidationError(_(u'Filesize exceeds allowed Upload Size.'))
        return self.cleaned_data['file']
        

filebrowser/templates/filebrowser/append.html
{% load i18n %}

<div class="module">
    <table>
        <caption>{% trans "File-Browser" %}</caption>
        <tr class="row2">
            <th scope="row"><a href="{% url filebrowser-index %}">{% trans "File-Browser" %}</a></th>
            <td> </td>
            <td> </td>
        </tr>
    </table>
</div>

filebrowser/templates/filebrowser/custom_field.html
<input id="{{ final_attrs.id }}" type="text" name="{{ final_attrs.name }}" value="{{ final_attrs.value }}" />
<a href="javascript:FileBrowser.show('{{ final_attrs.id }}', '{{ final_attrs.initial_directory }}?pop=1&filter_type={{ final_attrs.format }}');" class="fb_show">
    <img src="{{ final_attrs.search_icon }}" alt="" />
</a>
{% if final_attrs.value %}
<p class="help" id="help_{{ final_attrs.id }}">
    <a href="{{ final_attrs.preview }}" target="_blank" id="link_{{ final_attrs.id }}">
        <img id="image_{{ final_attrs.id }}" alt="" class="preview" src="{{ final_attrs.thumbnail }}" />
    </a>
</p>
{% else %}
<p class="help" id="help_{{ final_attrs.id }}" style="display: none;">
    <a href="javascript://" target="_self" id="link_{{ final_attrs.id }}">
        <img id="image_{{ final_attrs.id }}" alt="" class="preview" src="" />
    </a>
</p>
{% endif %}

filebrowser/templates/filebrowser/index.html
{% extends "admin/base_site.html" %}
{% load i18n %}
{% load adminmedia %}

{% block extrahead %}{{ block.super }}
{% with query.pop|slice:":5" as pop %}
{% ifequal pop 'pop=1' %} <!-- FileBrowseField -->
<script language="javascript" type="text/javascript" src="{{ settings_var.URL_FILEBROWSER_MEDIA }}js/FB_FileBrowseField.js"></script>
{% endifequal %}
{% ifequal pop 'pop=2' %} <!-- TinyMCE -->
<script language="javascript" type="text/javascript" src="{{ settings_var.URL_TINYMCE }}tiny_mce_popup.js"></script>
<script language="javascript" type="text/javascript" src="{{ settings_var.URL_FILEBROWSER_MEDIA }}js/FB_TinyMCE.js"></script>
{% if query.mce_rdomain %}<script language="javascript">document.domain = "{{ query.mce_rdomain }}"</script>{% endif %}
{% endifequal %}
{% endwith %}
{% endblock %}
{% block coltype %}flex{% endblock %}
{% block bodyclass %}change-list filebrowser{% endblock %}
{% block extrastyle %}{{ block.super }}
<link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/changelists.css" />
<link rel="stylesheet" type="text/css" href="{{ settings_var.URL_FILEBROWSER_MEDIA }}css/filebrowser.css" />
{% if query.pop %}
<style type="text/css">
#header { display: none; }
</style>
{% endif %}
{% endblock %}
{% block breadcrumbs %}<div class="breadcrumbs">{{ breadcrumbs }}</div>{% endblock %}

{% block content %}
<div id="content-main">
    <ul class="object-tools">
        <li><a href="mkdir/{{ query.query_str_total }}">{% trans "New Folder" %}</a></li>
        <li><a href="makethumbs/{{ query.query_str_total }}">{% trans "Make Thumbs" %}</a></li>
        {% if settings_var.USE_IMAGE_GENERATOR and results_var.imagegenerator_total %}<li><a href="generateimages/{{ query.query_str_total }}" class="fb_imagegeneratorlink">{% trans "Generate Images" %}</a></li>{% endif %}
        <li><a href="upload/{{ query.query_str_total }}" class="focus">{% trans "Upload" %}</a></li>
    </ul>
    <div class="module filtered" id="changelist">
        {% include "filebrowser/include/toolbar.html" %}
        {% include "filebrowser/include/filter.html" %}
        <div id="toolbartable">
        <table cellspacing="0">
            {% if results_var.results_current %}
                {% include "filebrowser/include/tableheader.html" %}
            {% endif %}
            <tbody>
            {% for file in file_dict %}
                {% include "filebrowser/include/filelisting.html" %}
            {% endfor %}
            </tbody>
        </table>
        </div>
        {% include "filebrowser/include/paginator.html" %}
    </div>
</div>
{% endblock %}

filebrowser/templates/filebrowser/makedir.html
{% extends "admin/base_site.html" %}
{% load i18n %}
{% load adminmedia %}

{% block coltype %}colM{% endblock %}
{% block bodyclass %}change-form{% endblock %}
{% block extrastyle %}{{ block.super }}
<link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/forms.css" />
<link rel="stylesheet" type="text/css" href="{{ settings_var.URL_FILEBROWSER_MEDIA }}css/filebrowser.css" />
{% if query.pop %}
<style type="text/css">
#header { display: none; }
</style>
{% endif %}
{% endblock %}

<!-- breadcrumbs -->
{% block breadcrumbs %}<div class="breadcrumbs">{{ breadcrumbs }}</div>{% endblock %}

{% block content %}
<div id="content-main">
    <form action="?{{ query.pop }}" method="post">
    <div>
        {% if form.errors %}<p class="errornote">{% trans 'Please correct the following errors.' %}</p>{% endif %}
        <fieldset class="module aligned">
        <div class="form-row {% if form.dir_name.errors %}errors{% endif %}">
            {% if form.dir_name.errors %}<ul class="errorlist">{{ form.dir_name.errors }}</ul>{% endif %}
            <label class="required" for="id_dir_name">{{ form.dir_name.label }}</label>
            {{ form.dir_name }}
            {% if form.dir_name.help_text %}<p class="help">{{ form.dir_name.help_text|safe }}</p>{% endif %}
        </div>
        </fieldset>
        <div class="submit-row">
            <input type="submit" value="{% trans 'Submit' %}" class="default" /><br class="clear" />
        </div>
    </div>
    </form>
</div>
{% endblock %}

filebrowser/templates/filebrowser/rename.html
{% extends "admin/base_site.html" %}
{% load i18n %}
{% load adminmedia %}

{% block coltype %}colM{% endblock %}
{% block bodyclass %}change-form{% endblock %}
{% block extrastyle %}{{ block.super }}
<link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/forms.css" />
<link rel="stylesheet" type="text/css" href="{{ settings_var.URL_FILEBROWSER_MEDIA }}css/filebrowser.css" />
{% if query.pop %}
<style type="text/css">
#header { display: none; }
</style>
{% endif %}
{% endblock %}
{% block breadcrumbs %}<div class="breadcrumbs">{{ breadcrumbs }}</div>{% endblock %}

{% block content %}
<div id="content-main">
    <form action="?{{ query.pop }}" method="post">
    <div>
        {% if form.errors %}<p class="errornote">{% trans 'Please correct the following errors.' %}</p>{% endif %}
        <fieldset class="module aligned">
        <div class="form-row {% if form.dir_name.errors %}errors{% endif %}">
            {% if form.name.errors %}<ul class="errorlist">{{ form.name.errors }}</ul>{% endif %}
            <label class="required" for="id_dir_name">{{ form.name.label }}</label>
            {{ form.name }}
            {% if file_extension %}<b>{{ file_extension }}</b>{% endif %}
            {% if form.name.help_text %}<p class="help">{{ form.name.help_text|safe }}</p>{% endif %}
        </div>
        </fieldset>
        <div class="submit-row">
            <input type="submit" value="{% trans 'Submit' %}" class="default" />
        </div>
    </div>
    </form>
</div>
{% endblock %}

filebrowser/templates/filebrowser/upload.html
{% extends "admin/base_site.html" %}
{% load i18n %}
{% load adminmedia %}

{% block extrahead %}{{ block.super }}
<script type="text/javascript" src="/admin/jsi18n/"></script>
<script type="text/javascript" src="{% admin_media_prefix %}js/core.js"></script>
<script type="text/javascript" src="{% admin_media_prefix %}js/admin/CollapsedFieldsets.js"></script>
{% endblock %}
{% block coltype %}colM{% endblock %}
{% block bodyclass %}change-form{% endblock %}
{% block extrastyle %}{{ block.super }}
<link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/forms.css" />
<link rel="stylesheet" type="text/css" href="{{ settings_var.URL_FILEBROWSER_MEDIA }}css/filebrowser.css" />
{% if query.pop %}
<style type="text/css">
#header { display: none; }
</style>
{% endif %}
{% endblock %}
{% block breadcrumbs %}<div class="breadcrumbs">{{ breadcrumbs }}</div>{% endblock %}

{% block content %}
<div id="content-main">
    <form enctype="multipart/form-data" action="?action=upload&{{ query.pop }}" method="post" name="FileForm">
    {{ formset.management_form }}
    <div>
        {% if form.errors %}{{ form.errors }}{% endif %}
        <fieldset class="module aligned ()">
        {% for form in formset.forms %}
        <div class="form-row">
            {% if form.file.errors %}{{ form.file.errors }}{% endif %}
            <label>{{ form.file.label }} {{ forloop.counter }}</label>
            {{ form.file }}
            {% if settings_var.USE_IMAGE_GENERATOR %}
                {% if settings_var.FORCE_GENERATOR %}
                    <p class="help">{% trans 'Will use image generator.' %}</p>
                {% else %}
                    <p class="help">{{ form.use_image_generator }} {{ form.use_image_generator.label }}</p>
                {% endif %}
            {% endif %}
        </div>
        {% endfor %}
        </fieldset>
        
        <fieldset class="module aligned collapse">
        <h2>{% trans "Help" %}</h2>
        <div class="form-row" >
            {% for extension in settings_var.EXTENSIONS.items %}
            {% ifnotequal extension.0 'Folder' %}
            <label for="id_body" class="required">{% if forloop.first %}{% trans "Allowed" %}:{% else %}&nbsp;{% endif %}</label> 
            <p>{{ extension.0|safe }} ({{ extension.1|join:", "|safe }})</p>
            {% endifnotequal %}
            {% endfor %}
        </div>
        <div class="form-row" >
            <label for="id_body" class="required">{% trans "Max. Filesize" %}:</label> 
            <p class="help">{{ settings_var.MAX_UPLOAD_SIZE|safe }}</p>
        </div>
        </fieldset>
        <div class="submit-row">
            <input type="submit" value="{% trans 'Upload' %}" class="default" /><br class="clear" />
        </div>
    </div>
    </form>
    
</div>
{% endblock %}